//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#ifndef MV_APPLICATION_H
#define MV_APPLICATION_H


#include <vector>
#include <string>
#include <map>

#include <Entry.h>
#include <Application.h>


class MVApplication : public BApplication
{
public:
  MVApplication(void);
  virtual ~MVApplication(void);

  void GetWindowList(vector<BWindow *> &outList);
  int ActiveWindow(void);

private:
  virtual void RefsReceived(BMessage *msg);
  virtual void ArgvReceived(int32 argc, char **argv);
  virtual void ReadyToRun(void);
  virtual void MessageReceived(BMessage *msg);
  virtual void AboutRequested(void);

  void OpenWindow(const entry_ref &ref);
  void WindowClosed(const entry_ref &ref);
  void ActivateWindow(int index);
  void NextWindow(void);
  void PrevWindow(void);
  void InitAboutContents(void);

  map<entry_ref, BWindow*> mWin;
  vector<BWindow*> mWinList;
  int mWinCount;
  string mAboutContents;
};


#endif

