//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#ifndef MV_CONTROL_APPLICATION_STATE_H
#define MV_CONTROL_APPLICATION_STATE_H


#include "MVControlState.h"


class MVControlApplicationState : public MVControlState
{
public:
  static MVControlApplicationState *Instance(void);

protected:
  virtual void AllAttached(MVControlView *view);
  virtual void KeyDown(MVControlView *view, 
		       const char *bytes, int32 numBytes);
  virtual void FrameResized(MVControlView *view,
			    float width, float height);
  virtual void MouseDown(MVControlView *view, 
			 BPoint point);
  virtual void MessageReceived(MVControlView *view,
			       BMessage *msg);

private:
  MVControlApplicationState(void);

  void ZoomIn(MVControlView *view, int32 modifiers = 0);
  void ZoomOut(MVControlView *view, int32 modifiers = 0);
  void Normalize(MVControlView *view);
  void FitToScreen(MVControlView *view);
  void ActivateWindow(MVControlView *view, int index);
  void PreviousWindow(MVControlView *view);
  void NextWindow(MVControlView *view);
  void CloseWindow(MVControlView *view);
  void QuitApplication(MVControlView *view);
};


#endif
