//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#include <string>
#include <Font.h>

#include "MVControlView.h"
#include "MVControlNullState.h"


MVControlNullState *
MVControlNullState::Instance(void)
{
  static MVControlNullState *instance;

  if (! instance)
    instance = new MVControlNullState();

  return instance;
}


MVControlNullState::MVControlNullState(void)
{
}


void
MVControlNullState::Draw(MVControlView *view,
			 BRect updateRect)
{
  string notFound(view->mRef.name);
  float width, height;
  font_height h;
  notFound += " not found.";

  view->SetFont(be_bold_font);

  width = be_bold_font->StringWidth(notFound.c_str());
  be_bold_font->GetHeight(&h);
  height = h.ascent + h.descent + h.leading;

  view->SetHighColor(255, 255, 255);
  view->FillRect(view->Bounds());
  view->SetHighColor(0, 0, 0);
  view->DrawString(notFound.c_str(),
		   BPoint((view->Bounds().Width() - width) / 2,
			  (view->Bounds().Height() + height) / 2));

  view->MVReplicantableView::Draw(updateRect);
}


void
MVControlNullState::MouseDown(MVControlView *view,
			 BPoint point)
{
}


void 
MVControlNullState::MouseMoved(MVControlView *view, 
				BPoint point, uint32 transit,
				const BMessage *msg)
{
}


void 
MVControlNullState::MouseUp(MVControlView *view,
			     BPoint point)
{
}


