//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#include <Window.h>
#include "MVDefs.h"
#include "MVControlView.h"
#include "MVControlReplicantState.h"


MVControlReplicantState *
MVControlReplicantState::Instance(void)
{
  static MVControlReplicantState *instance;

  if (!instance)
    instance = new MVControlReplicantState();

  return instance;
}


MVControlReplicantState::MVControlReplicantState(void)
{
}


void
MVControlReplicantState::KeyDown(MVControlView *view, 
				 const char *bytes, int32 numBytes)
{
  if (numBytes != 1)
    return;

  switch (bytes[0])
    {
    case '+':
      view->ChangeMagnification(view->mMagnification * MV_KEY_MAGNIFICATION);
      view->InscribedToFrame();
      view->Invalidate();
      break;

    case '-':
      view->ChangeMagnification(view->mMagnification / MV_KEY_MAGNIFICATION);
      view->InscribedToFrame();
      view->Invalidate();
      break;

    case '/':
      view->ChangeMagnification(1.0);
      view->InscribedToFrame();
      view->Invalidate();
      break;
    }
}


void 
MVControlReplicantState::MouseDown(MVControlView *view,
				    BPoint point)
{
  MVControlState::MouseDown(view, point);
  view->Window()->Activate();
}


void 
MVControlReplicantState::MouseUp(MVControlView *view,
				 BPoint point)
{
  MVControlState::MouseUp(view, point);
  view->MakeFocus();
}


