//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#ifndef MV_CONTROL_STATE_H
#define MV_CONTROL_STATE_H


#include <Rect.h>
#include <Point.h>


class MVControlView;
class BMessage;


class MVControlState
{
public:
  virtual void AllAttached(MVControlView *view);
  virtual void AllDetached(MVControlView *view);
  virtual void FrameResized(MVControlView *view,
			    float width, float height);
  virtual void Draw(MVControlView *view, 
		    BRect updateRect);
  virtual void KeyDown(MVControlView *view, 
		       const char *bytes, int32 numBytes);
  virtual void MouseDown(MVControlView *view,
			 BPoint point);
  virtual void MouseMoved(MVControlView *view, 
			  BPoint point, uint32 transit, const BMessage *msg);
  virtual void MouseUp(MVControlView *view,
		       BPoint point);
  virtual void MessageReceived(MVControlView *view,
			       BMessage *msg);

protected:
  MVControlState(void);

};


#endif
