//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#ifndef MV_DEFS_H
#define MV_DEFS_H


#include <iostream>


#define MV_SIGNATURE "application/x-vnd.Kamnagi.MonoView2"
#define MV_TRACKER_SIGNATURE "application/x-vnd.Be-TRAK"

enum
{
  MV_WIN_CLOSED = 'Mwcr',  // Ref:refs:entry_ref the window handled.

  MV_ZOOM_IN = 'Mzin',
  MV_ZOOM_IN_WITHOUT_RESIZE = 'Mziw',
  MV_ZOOM_OUT = 'Mzou',
  MV_ZOOM_OUT_WITHOUT_RESIZE = 'Mzow',
  MV_NORMALIZE = 'Mnrm',
  MV_FIT_TO_SCREEN = 'Mfts',

  MV_ACTIVATE_WINDOW = 'Mawr',  // index: index of target window.
  MV_NEXT_WINDOW = 'Mnwr',
  MV_PREV_WINDOW = 'Mpwr',

  MV_CLOSE_WINDOW = 'Mcwn',
  MV_QUIT_APPLICATION = 'Mqap',

  MV_IGNORE_NEXT_RESIZE = 'Minr',

  MV_TOGGLE_LOCK = 'Mtlr',
  MV_SET_WORKSPACE = 'Mswr',
};


static const float MV_KEY_MAGNIFICATION = 1.25992105;


#endif

