//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#include <Window.h>
#include <MenuItem.h>
#include "MVDefs.h"
#include "MVApplication.h"
#include "MVControlView.h"
#include "MVPopUpMenu.h"


MVPopUpMenu::MVPopUpMenu(BView *target)
  : BPopUpMenu(NULL, false, false)
{
  BMenuItem *item;
  BMenu *menu;

  //  this->SetAsyncAutoDestruct(true);

  menu = new BMenu("Zoom");
  menu->AddItem(new BMenuItem("In", new BMessage(MV_ZOOM_IN)));
  menu->AddItem(new BMenuItem("In winthout Resize",
			      new BMessage(MV_ZOOM_IN_WITHOUT_RESIZE)));
  menu->AddItem(new BMenuItem("Out", new BMessage(MV_ZOOM_OUT)));
  menu->AddItem(new BMenuItem("Out winthout Resize",
			      new BMessage(MV_ZOOM_OUT_WITHOUT_RESIZE)));
  menu->AddItem(new BMenuItem("100%", new BMessage(MV_NORMALIZE)));
  menu->AddItem(new BMenuItem("Fit To Screen",
			      new BMessage(MV_FIT_TO_SCREEN)));
  menu->SetTargetForItems(target);

  this->AddItem(menu);
  this->AddSeparatorItem();

  menu = new BMenu("Window");
  menu->AddItem(new BMenuItem("Previous", new BMessage(MV_PREV_WINDOW)));
  menu->AddItem(new BMenuItem("Next", new BMessage(MV_NEXT_WINDOW)));
  menu->AddSeparatorItem();

  vector<BWindow *> winList;
  static_cast<MVApplication*>(be_app)->GetWindowList(winList);
  int active = static_cast<MVApplication*>(be_app)->ActiveWindow();

  for (int i = 0; i < winList.size(); i++)
    {
      const char *fileName;
      winList[i]->Lock();
      fileName = 
	static_cast<MVControlView*>(winList[i]->ChildAt(0))->FileName();
      winList[i]->Unlock();
      BMessage *msg = new BMessage(MV_ACTIVATE_WINDOW);
      msg->AddInt32("index", i);
      item = new BMenuItem(fileName, msg);
      if (i == active)
	item->SetMarked(true);
      menu->AddItem(item);
    }

  menu->SetTargetForItems(target);

  this->AddItem(menu);
  this->AddSeparatorItem();

  item = new BMenuItem("About", new BMessage(B_ABOUT_REQUESTED));
  item->SetTarget(be_app);
  this->AddItem(item);

  item = new BMenuItem("Close", new BMessage(MV_CLOSE_WINDOW));
  item->SetTarget(target);
  this->AddItem(item);

  this->AddSeparatorItem();

  item = new BMenuItem("Quit", new BMessage(MV_QUIT_APPLICATION));
  item->SetTarget(target);
  this->AddItem(item);
}
