//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#include <View.h>
#include <Message.h>

#include "MVDefs.h"
#include "MVReplicantableView.h"
#include "MVReplicantInputFilter.h"


MVReplicantInputFilter::MVReplicantInputFilter
(MVReplicantableView *target)
  : BMessageFilter(B_ANY_DELIVERY, B_ANY_SOURCE)
  , mTarget(target)
{
}



filter_result
MVReplicantInputFilter::Filter(BMessage *msg, BHandler **target)
{
  if (! mTarget->IsLocked())
    return B_DISPATCH_MESSAGE;;

  switch (msg->what)
    {
    case B_MOUSE_DOWN:
    case B_MOUSE_MOVED:
    case B_MOUSE_UP:
      if (mTarget->IsOnTracker())
	{
	  BPoint point;
	  
	  if (msg->what != B_MOUSE_MOVED)
	    {
	      point = msg->FindPoint("where");
	      point = mTarget->ConvertToParent(point);
	      msg->ReplacePoint("where", point);
	    }
	  
	  point = msg->FindPoint("be:view_where");
	  point = mTarget->ConvertToParent(point);
	  msg->ReplacePoint("be:view_where", point);
	  
	  *target = mTarget->Parent();
	  
	  return B_DISPATCH_MESSAGE;
	}
      else
	return B_SKIP_MESSAGE;
      
    case B_KEY_DOWN:
      if (mTarget->IsOnTracker())
	{
	  *target = mTarget->Parent();
	  return B_DISPATCH_MESSAGE;
	}
      else
	return B_SKIP_MESSAGE;
      
    default:
      break;
    }

  return B_DISPATCH_MESSAGE;
}

