//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#ifndef MV_REPLICANTABLE_VIEW_H
#define MV_REPLICANTABLE_VIEW_H


#include <string>
#include <View.h>


class BDragger;
class BMenu;
class MVForwardFilter;
class MVWorkspaceMenu;


class MVReplicantableView : public BView
{
  friend class MVReplicantInputFilter;

public:
  MVReplicantableView(BRect frame, 
		    const char *name,
		    uint32 resizingMode,
		    uint32 flags);
  MVReplicantableView(BMessage *archive);
  virtual ~MVReplicantableView(void);
  virtual status_t Archive(BMessage *archive, bool deep = true) const; 

  virtual void SetMenu(BMenu *menu);

  virtual void MessageReceived(BMessage *msg);

  void SetAboutContents(const string &about);

protected:
  virtual void AllAttached(void);
  virtual void AllDetached(void);
  virtual void Draw(BRect updateRect);

  bool IsReplicant(void) const;
  bool IsOnTracker(void) const;
  bool IsLocked(void) const;

private:
  void WorkspaceActivated(void);

  BDragger *mDragger;

  bool mIsReplicant;
  bool mLock;
  bool mOnTracker;

  MVForwardFilter *mWorkspaceFilter;
  MVWorkspaceMenu *mWorkspaceMenu;
  string mAboutContents;
};


#endif
