//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#ifndef MV_VIDEO_VIEW_H
#define MV_VIDEO_VIEW_H


#include <Locker.h>
#include <OS.h>

#include "MVControlView.h"


class BMediaFile;
class BMediaTrack;
class BMessageRunnner;


class _EXPORT MVVideoView : public MVControlView
{
public:
  MVVideoView(const entry_ref &ref);
  MVVideoView(BMessage *archive);
  virtual ~MVVideoView(void);

  static BArchivable *Instantiate(BMessage *archive);

  virtual status_t Archive(BMessage *msg, bool deep) const;

  virtual status_t InitCheck(void);

protected:
  virtual void AllAttached(void);
  virtual void AllDetached(void);
  virtual void Hide(void);
  virtual void Show(void);
  virtual void MessageReceived(BMessage *msg);

private:
  void Init(void);
  void Start(void);
  void Stop(void);
  void Update(void);
  static int32 _PlaybackLoop(void *data);
  void PlaybackLoop(void);

  status_t mErr;
  BMediaFile *mFile;
  BMediaTrack *mTrack;
  int mActiveBuffer;
  BBitmap *mBackBuffer;
  
  thread_id mPlaybackThread;
  bool mIsPlaying;
  BMessageRunner *mPlaybackNotifier;
};


#endif
