//
//  'MonoView' image/video wallpaper for BeOS.
//  Copyright (C) 1999, 2000
//  Okada Jun (yun@be-in.org)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  MonoView is yet another wallpaper running on BeOS Intel and PPC,
//  originally designed and developed by Okada Jun in 1999.
//  http://www.be-in.org/~yun/
//


#ifndef MV_WORKSPACE_MENU_H
#define MV_WORKSPACE_MENU_H


#include <BeBuild.h>
#include <Menu.h>
#include <Window.h>


class _EXPORT MVWorkspaceMenu : public BMenu
{
public:
  MVWorkspaceMenu(const char *name, int32 workspace = B_ALL_WORKSPACES);
  MVWorkspaceMenu(BMessage *archive);
  static BArchivable *Instantiate(BMessage *archive);
  virtual status_t Archive(BMessage *archive, bool deep = true) const;
  virtual ~MVWorkspaceMenu(void);

  void SetTarget(BHandler *target);
  void SetWorkspace(int32 workspace);
  int32 Workspace(void);

protected:
  bool AddDynamicItem(add_state e);

private:
  void InitItems(void);
  void UpdateItems(void);

  BHandler *mTarget;
};
	

#endif
